<template>
  <b-tab title-link-class="custom-tabs">
    <template #title>
      <b-icon icon="chat"></b-icon> Infobulles
    </template>
    <h3 class="line-header">Infobulles</h3>
    <b-alert v-if="errorTxt !== null" show variant="warning" dismissible>{{errorTxt}}</b-alert>
    Les Infobulles sont affichés quand vous passez la souris sur une entité de la couche.
    <b-row class="mb-3">
      <b-col cols="4">
        <b-form-checkbox
          v-model="layer.popupInfos.active" switch @change="onChange()">
            Activer les Infobulles
        </b-form-checkbox>
      </b-col>
    </b-row>
    <b-row class="mb-5">
      <b-col cols="12" v-if="editor!=null && layer.popupInfos.active && editorLoaded">
        <ckeditor :editor="editor"
          v-model="layer.popupInfos.content" :config="editorConfig"></ckeditor>
      </b-col>
    </b-row>

  </b-tab>
</template>

<script lang="ts">
/* eslint-disable no-param-reassign */
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import FormTextInput from '@/components/shared/FormTextInput.vue';
import LayerConfig from '@/models/map-context/LayerConfig';
/* import ClassicEditor from '@ckeditor/ckeditor5-build-classic'; */
import Component from 'vue-class-component';
// import * as Editor from '../../../../lib/ckeditor5/build/ckeditor';
import * as Editor from 'ckeditor';
import BaseComponent from '../../BaseComponent';

@Component({
  props: {
    layer: LayerConfig,
  },
  components: {
    FormTextInput,
  },
})
export default class SingleLayerPopupInfos extends BaseComponent {
  layer!: LayerConfig;

  errorTxt:string|null=null;

  editor = Editor;

  editorData= '<p>Content of the editor.</p>';

  editorLoaded = false;

  editorConfig= {
    toolbar: {
      items: [
        'heading',
        '|',
        'bold',
        'italic',
        'link',
        'bulletedList',
        'numberedList',
        '|',
        'outdent',
        'indent',
        '|',
        'imageInsert',
        '|',
        'blockQuote',
        'insertTable',
        // 'mediaEmbed',
        'undo',
        'redo',
        '|',
        'fontColor',
        'fontFamily',
        'fontSize',
        'highlight',
        'specialCharacters',
        'horizontalLine',
      ],
    },
    language: 'fr',
    image: {
      toolbar: [
        'imageTextAlternative',
        'imageStyle:full',
        'imageStyle:side',
        'resizeImage',
        'linkImage',
      ],
      styles: [
        'full',
        'side',
      ],
    },
    table: {
      contentToolbar: [
        'tableColumn',
        'tableRow',
        'mergeTableCells',
        'tableCellProperties',
        'tableProperties',
      ],
    },
    licenseKey: '',
  };

  mounted() {
    // this.editor = ClassicEditor;
    console.log('SingleLayerPopupInfos');
    if (this.layer.popupInfos.active) {
      this.editorLoaded = true;
    }
  }

  onChange() {
    if (this.layer.popupInfos.active && (this.layer.popupInfos.content === '' || this.layer.popupInfos.content === undefined)) {
      this.initInfoBulles();
    }
    this.editorLoaded = true;
  }

  initInfoBulles() {
    this.layer.popupInfos.content = '';
    if (this.layer.layerProperties) {
      for (let i = 0; i < this.layer.layerProperties.length; i += 1) {
        this.layer.popupInfos.content += `<p>${this.layer.layerProperties[i].name}:{${this.layer.layerProperties[i].name}}</p>`;
      }
    }
  }
}
</script>

<style scoped lang="less">
</style>
